/*

How-explanations automatic generator

2007/12/14
Luis
*/



:- op(10, xfy, then).
:- op(100, fy, if).


:- op(1000, xfy, and).
:- op(1100, xfy, or).


:- dynamic fact/1.


rule(A, B):- if A then B.



solve(P):-
	solve(P, Proof),
	explain_proof(Proof).

solve((A and B), (ProofA, ProofB)):-
	!,
	solve(A, ProofA),
	solve(B, ProofB).
solve((A,B), (ProofA, ProofB)):-
	!,
	solve(A, ProofA),
	solve(B, ProofB).
solve(P, (P:-fact)):-
	fact(P).
solve(not(P), (not(P):- failed(P))):-
	\+ solve(P, _).
solve(P, (P:- fact)):-
	P \= not(_),
	system_predicate(P),
	!,
	call(P).
solve(P, (P:-Proof)):-
	rule(Cond, P),
	solve(Cond, Proof).

explain_proof((ProofA, ProofB)):-
	!,
	explain_proof(ProofA),
	explain_proof(ProofB).
explain_proof((not(P) :- failed(P))):-
	!,
	write_list([not(P), ' is true because I could not prove ', P]), nl.
explain_proof((P:-fact)):-
	write_list([P, ' is known to be true']), nl.
explain_proof((P:-Proof)):-
	extract_first_level(Proof, FirstLevel),
	display_rule((P:-FirstLevel)), nl,
	explain_proof(Proof).

extract_first_level((A:-ProofA), A).
extract_first_level(((A:-ProofA), Rest), (A, B)):-
	extract_first_level(Rest, B).


display_rule((Q:-R)):-
	write('IF '),
	display_condition(R),
	write_list([' THEN ', Q]),
	nl.


display_condition((A, B)):-
	!,
	write_list([A, ' AND ']),
	display_condition(B).
display_condition(P):-
	write(P).



write_list([X|Rest]):-
	write(X),
	write_list(Rest).
write_list([]).




system_predicate(P):-
	predicate_property(P, built_in), !.



% KB
if (q(X), r(X)) then p(X).
fact(q(a)).
fact(r(a)).

fact(q(b)).
fact(r(b)).
fact(t(b)).
