/*

Why explanations automatic generator

2007/12/14
Luis
*/

:- op(10, xfy, then).
:- op(100, fy, if).


:- op(1000, xfy, and).
:- op(1100, xfy, or).



:- dynamic fact/1.



rule(A, B):- if A then B.



solve(P):-
	solve(P, []).

solve((A and B), Reasons):-
	!,
	solve(A, Reasons),
	solve(B, Reasons).
solve((A,B), Reasons):-
	!,
	solve(A, Reasons),
	solve(B, Reasons).
solve(P, _):-
	fact(P).
solve(not(P), _):-
	!, \+ solve(P, _).
solve(P, _):-
	system_predicate(P),
	!,
	call(P).
solve(P, Reasons):-
	rule(Cond, P),
	solve(Cond, [(P:-Cond)|Reasons]).
solve(P, Reasons):-
	askable(P),
	\+ known(P),
	ask(P, Answer),
	process_answer(P, Answer, Reasons).





system_predicate(P):-
	predicate_property(P, built_in), !.


ask(P, Answer):-
	write(P), write(' yes/no/<fact>/why? '),
	read(Answer).


known(P):-
	(fact(P); fact(not(P))), !.

process_answer(P, yes, _):-
	!,
	assert(fact(P)).
process_answer(P, P, _):-
	!,
	assert(fact(P)).
process_answer(P, no, _):-
	!,
	assert(fact(not(P))),
	fail.
process_answer(P, why, [(Q:-R)|Reasons]):-
	!,
	display_rule((Q:-R)), nl,
	ask(P, Answer),
	process_answer(P, Answer, Reasons).
process_answer(P, why, []):-
	!,
	write('I have no more explanations to give '), nl,
	ask(P, Answer),
	process_answer(P, Answer, []).
process_answer(P, A, Reasons):-
	write_list([A, ': invalid answer. Try again.']), nl,
	ask(P, Answer),
	process_answer(P, Answer, []).

display_rule((Q:-R)):-
	write('IF '), display_cond(R), nl,
	write_list(['THEN ', Q]).

display_cond((P, Cond)):-
	write_list([P, ' and ']),
	display_cond(Cond).
display_cond(P):-
	P \= (_, _),
	write(P).


write_list([X|Rest]):-
	write(X),
	write_list(Rest).
write_list([]).


% KB

if (q, r) then p.
if (s, t) then q.
askable(r).
askable(s).
askable(t).






